# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2011 Claudio Novais <ubuntued+walls@gmail.com>
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE
import pycurl
import xml.dom.minidom
import StringIO
import sys
import gtk
import os
import imghdr
import locale
import gettext
try:
    import pynotify
except:
    print "Install pynotify. It's whoasome!"
    
APP="Imgur Uploader"
DIR="locale"

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(APP, DIR)
gettext.textdomain(APP)
_ = gettext.gettext

##STRINGS
notimg = _("is not an image.")
notallowed = _("is not an allowed file type. Skipping.")
uploading = _("Uploading")
oneimage = _("1 image has been uploaded.")
multimages = _("images have been uploaded.")
uploadfailed = _("Unable to upload")

class Uploadr:
    def upload(self, file):
        c = pycurl.Curl()
                
        values = [
                ("key", "e85c0044b9222bc9a2813679a452f54f"),
                ("image", (c.FORM_FILE, file))]
                        
        buf = StringIO.StringIO()
                
        c.setopt(c.URL, "http://imgur.com/api/upload.xml")
        c.setopt(c.HTTPPOST, values)
        c.setopt(c.WRITEFUNCTION, buf.write)
                
        if c.perform():
            self.broadcasts.append(uploadfailed+" "+file+".")
            c.close()
            return ""
        
        self.result = buf.getvalue()
        c.close()
        
        doc = xml.dom.minidom.parseString(self.result)

        return doc.getElementsByTagName("original_image")[0].childNodes[0].nodeValue
